907945b349bec3c86f0cb8bee7a2543c3f76e824
[openwrt/staging/dedeckeh.git] / package / base-files / files / lib / upgrade / nand.sh
1 # Copyright (C) 2014 OpenWrt.org
2 #
3
4 . /lib/functions.sh
5
6 # 'kernel' partition or UBI volume on NAND contains the kernel
7 CI_KERNPART="${CI_KERNPART:-kernel}"
8
9 # 'ubi' partition on NAND contains UBI
10 # There are also CI_KERN_UBIPART and CI_ROOT_UBIPART if kernel
11 # and rootfs are on separated UBIs.
12 CI_UBIPART="${CI_UBIPART:-ubi}"
13
14 # 'rootfs' UBI volume on NAND contains the rootfs
15 CI_ROOTPART="${CI_ROOTPART:-rootfs}"
16
17 ubi_mknod() {
18 local dir="$1"
19 local dev="/dev/$(basename $dir)"
20
21 [ -e "$dev" ] && return 0
22
23 local devid="$(cat $dir/dev)"
24 local major="${devid%%:*}"
25 local minor="${devid##*:}"
26 mknod "$dev" c $major $minor
27 }
28
29 nand_find_volume() {
30 local ubidevdir ubivoldir
31 ubidevdir="/sys/class/ubi/"
32 [ ! -d "$ubidevdir" ] && return 1
33 for ubivoldir in $ubidevdir/${1}_*; do
34 [ ! -d "$ubivoldir" ] && continue
35 if [ "$( cat $ubivoldir/name )" = "$2" ]; then
36 basename $ubivoldir
37 ubi_mknod "$ubivoldir"
38 return 0
39 fi
40 done
41 }
42
43 nand_find_ubi() {
44 local ubidevdir ubidev mtdnum cmtdnum
45 mtdnum="$( find_mtd_index $1 )"
46 [ ! "$mtdnum" ] && return 1
47 for ubidevdir in /sys/class/ubi/ubi*; do
48 [ ! -e "$ubidevdir/mtd_num" ] && continue
49 cmtdnum="$( cat $ubidevdir/mtd_num )"
50 if [ "$mtdnum" = "$cmtdnum" ]; then
51 ubidev=$( basename $ubidevdir )
52 ubi_mknod "$ubidevdir"
53 echo $ubidev
54 return 0
55 fi
56 done
57 }
58
59 nand_get_magic_long() {
60 (${3}cat "$1" | dd bs=4 "skip=${2:-0}" count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2> /dev/null
61 }
62
63 get_magic_long_tar() {
64 (tar xO${3}f "$1" "$2" | dd bs=4 count=1 | hexdump -v -n 4 -e '1/1 "%02x"') 2> /dev/null
65 }
66
67 identify() {
68 identify_magic_long $(nand_get_magic_long "$@")
69 }
70
71 identify_tar() {
72 identify_magic_long $(get_magic_long_tar "$@")
73 }
74
75 identify_if_gzip() {
76 if [ "$(identify "$1")" = gzip ]; then echo -n z; fi
77 }
78
79 nand_restore_config() {
80 local ubidev=$( nand_find_ubi "${CI_ROOT_UBIPART:-$CI_UBIPART}" )
81 local ubivol="$( nand_find_volume $ubidev rootfs_data )"
82 if [ ! "$ubivol" ]; then
83 ubivol="$( nand_find_volume $ubidev "$CI_ROOTPART" )"
84 if [ ! "$ubivol" ]; then
85 echo "cannot find ubifs data volume"
86 return 1
87 fi
88 fi
89 mkdir /tmp/new_root
90 if ! mount -t ubifs /dev/$ubivol /tmp/new_root; then
91 echo "cannot mount ubifs volume $ubivol"
92 rmdir /tmp/new_root
93 return 1
94 fi
95 if mv "$1" "/tmp/new_root/$BACKUP_FILE"; then
96 if umount /tmp/new_root; then
97 echo "configuration saved"
98 rmdir /tmp/new_root
99 return 0
100 fi
101 else
102 umount /tmp/new_root
103 fi
104 echo "could not save configuration to ubifs volume $ubivol"
105 rmdir /tmp/new_root
106 return 1
107 }
108
109 nand_remove_ubiblock() {
110 local ubivol="$1"
111
112 local ubiblk="ubiblock${ubivol:3}"
113 if [ -e "/dev/$ubiblk" ]; then
114 umount "/dev/$ubiblk" && echo "unmounted /dev/$ubiblk" || :
115 if ! ubiblock -r "/dev/$ubivol"; then
116 echo "cannot remove $ubiblk"
117 return 1
118 fi
119 fi
120 }
121
122 nand_attach_ubi() {
123 local ubipart="$1"
124 local has_env="${2:-0}"
125
126 local mtdnum="$( find_mtd_index "$ubipart" )"
127 if [ ! "$mtdnum" ]; then
128 >&2 echo "cannot find ubi mtd partition $ubipart"
129 return 1
130 fi
131
132 local ubidev="$( nand_find_ubi "$ubipart" )"
133 if [ ! "$ubidev" ]; then
134 >&2 ubiattach -m "$mtdnum"
135 ubidev="$( nand_find_ubi "$ubipart" )"
136
137 if [ ! "$ubidev" ]; then
138 >&2 ubiformat /dev/mtd$mtdnum -y
139 >&2 ubiattach -m "$mtdnum"
140 ubidev="$( nand_find_ubi "$ubipart" )"
141
142 if [ ! "$ubidev" ]; then
143 >&2 echo "cannot attach ubi mtd partition $ubipart"
144 return 1
145 fi
146
147 if [ "$has_env" -gt 0 ]; then
148 >&2 ubimkvol /dev/$ubidev -n 0 -N ubootenv -s 1MiB
149 >&2 ubimkvol /dev/$ubidev -n 1 -N ubootenv2 -s 1MiB
150 fi
151 fi
152 fi
153
154 echo "$ubidev"
155 return 0
156 }
157
158 nand_detach_ubi() {
159 local ubipart="$1"
160
161 local mtdnum="$( find_mtd_index "$ubipart" )"
162 if [ ! "$mtdnum" ]; then
163 echo "cannot find ubi mtd partition $ubipart"
164 return 1
165 fi
166
167 local ubidev="$( nand_find_ubi "$ubipart" )"
168 if [ "$ubidev" ]; then
169 for ubivol in $(find /dev -name "${ubidev}_*" -maxdepth 1 | sort); do
170 ubivol="${ubivol:5}"
171 nand_remove_ubiblock "$ubivol" || :
172 umount "/dev/$ubivol" && echo "unmounted /dev/$ubivol" || :
173 done
174 if ! ubidetach -m "$mtdnum"; then
175 echo "cannot detach ubi mtd partition $ubipart"
176 return 1
177 fi
178 fi
179 }
180
181 nand_upgrade_prepare_ubi() {
182 local rootfs_length="$1"
183 local rootfs_type="$2"
184 local rootfs_data_max="$(fw_printenv -n rootfs_data_max 2> /dev/null)"
185 [ -n "$rootfs_data_max" ] && rootfs_data_max=$((rootfs_data_max))
186
187 local kernel_length="$3"
188 local has_env="${4:-0}"
189 local kern_ubidev
190 local root_ubidev
191
192 [ -n "$rootfs_length" -o -n "$kernel_length" ] || return 1
193
194 if [ -n "$CI_KERN_UBIPART" -a -n "$CI_ROOT_UBIPART" ]; then
195 kern_ubidev="$( nand_attach_ubi "$CI_KERN_UBIPART" "$has_env" )"
196 [ -n "$kern_ubidev" ] || return 1
197 root_ubidev="$( nand_attach_ubi "$CI_ROOT_UBIPART" )"
198 [ -n "$root_ubidev" ] || return 1
199 else
200 kern_ubidev="$( nand_attach_ubi "$CI_UBIPART" "$has_env" )"
201 [ -n "$kern_ubidev" ] || return 1
202 root_ubidev="$kern_ubidev"
203 fi
204
205 local kern_ubivol="$( nand_find_volume $kern_ubidev "$CI_KERNPART" )"
206 local root_ubivol="$( nand_find_volume $root_ubidev "$CI_ROOTPART" )"
207 local data_ubivol="$( nand_find_volume $root_ubidev rootfs_data )"
208 [ "$root_ubivol" = "$kern_ubivol" ] && root_ubivol=
209
210 # remove ubiblocks
211 [ "$kern_ubivol" ] && { nand_remove_ubiblock $kern_ubivol || return 1; }
212 [ "$root_ubivol" ] && { nand_remove_ubiblock $root_ubivol || return 1; }
213 [ "$data_ubivol" ] && { nand_remove_ubiblock $data_ubivol || return 1; }
214
215 # kill volumes
216 [ "$kern_ubivol" ] && ubirmvol /dev/$kern_ubidev -N "$CI_KERNPART" || :
217 [ "$root_ubivol" ] && ubirmvol /dev/$root_ubidev -N "$CI_ROOTPART" || :
218 [ "$data_ubivol" ] && ubirmvol /dev/$root_ubidev -N rootfs_data || :
219
220 # create kernel vol
221 if [ -n "$kernel_length" ]; then
222 if ! ubimkvol /dev/$kern_ubidev -N "$CI_KERNPART" -s $kernel_length; then
223 echo "cannot create kernel volume"
224 return 1;
225 fi
226 fi
227
228 # create rootfs vol
229 if [ -n "$rootfs_length" ]; then
230 local rootfs_size_param
231 if [ "$rootfs_type" = "ubifs" ]; then
232 rootfs_size_param="-m"
233 else
234 rootfs_size_param="-s $rootfs_length"
235 fi
236 if ! ubimkvol /dev/$root_ubidev -N "$CI_ROOTPART" $rootfs_size_param; then
237 echo "cannot create rootfs volume"
238 return 1;
239 fi
240 fi
241
242 # create rootfs_data vol for non-ubifs rootfs
243 if [ "$rootfs_type" != "ubifs" ]; then
244 local rootfs_data_size_param="-m"
245 if [ -n "$rootfs_data_max" ]; then
246 rootfs_data_size_param="-s $rootfs_data_max"
247 fi
248 if ! ubimkvol /dev/$root_ubidev -N rootfs_data $rootfs_data_size_param; then
249 if ! ubimkvol /dev/$root_ubidev -N rootfs_data -m; then
250 echo "cannot initialize rootfs_data volume"
251 return 1
252 fi
253 fi
254 fi
255
256 return 0
257 }
258
259 # Write the UBI image to MTD ubi partition
260 nand_upgrade_ubinized() {
261 local ubi_file="$1"
262 local gz="$2"
263
264 nand_detach_ubi "$CI_UBIPART" || return 1
265
266 local mtdnum="$( find_mtd_index "$CI_UBIPART" )"
267 ${gz}cat "$ubi_file" | ubiformat "/dev/mtd$mtdnum" -y -f - && ubiattach -m "$mtdnum"
268 }
269
270 # Write the UBIFS image to UBI rootfs volume
271 nand_upgrade_ubifs() {
272 local ubifs_file="$1"
273 local gz="$2"
274
275 local ubifs_length=$( (${gz}cat "$ubifs_file" | wc -c) 2> /dev/null)
276
277 nand_upgrade_prepare_ubi "$ubifs_length" "ubifs" "" "" || return 1
278
279 local ubidev="$( nand_find_ubi "$CI_UBIPART" )"
280 local root_ubivol="$(nand_find_volume $ubidev "$CI_ROOTPART")"
281 ${gz}cat "$ubifs_file" | ubiupdatevol /dev/$root_ubivol -s "$ubifs_length" -
282 }
283
284 # Write the FIT image to UBI kernel volume
285 nand_upgrade_fit() {
286 local fit_file="$1"
287 local gz="$2"
288
289 local fit_length=$( (${gz}cat "$fit_file" | wc -c) 2> /dev/null)
290
291 nand_upgrade_prepare_ubi "" "" "$fit_length" "1" || return 1
292
293 local fit_ubidev="$(nand_find_ubi "$CI_UBIPART")"
294 local fit_ubivol="$(nand_find_volume $fit_ubidev "$CI_KERNPART")"
295 ${gz}cat "$fit_file" | ubiupdatevol /dev/$fit_ubivol -s "$fit_length" -
296 }
297
298 # Write images in the TAR file to MTD partitions and/or UBI volumes as required
299 nand_upgrade_tar() {
300 local tar_file="$1"
301 local gz="$2"
302
303 # WARNING: This fails if tar contains more than one 'sysupgrade-*' directory.
304 local board_dir="$(tar t${gz}f "$tar_file" | grep -m 1 '^sysupgrade-.*/$')"
305 board_dir="${board_dir%/}"
306
307 local kernel_mtd kernel_length
308 if [ "$CI_KERNPART" != "none" ]; then
309 kernel_mtd="$(find_mtd_index "$CI_KERNPART")"
310 kernel_length=$( (tar xO${gz}f "$tar_file" "$board_dir/kernel" | wc -c) 2> /dev/null)
311 [ "$kernel_length" = 0 ] && kernel_length=
312 fi
313 local rootfs_length=$( (tar xO${gz}f "$tar_file" "$board_dir/root" | wc -c) 2> /dev/null)
314 [ "$rootfs_length" = 0 ] && rootfs_length=
315 local rootfs_type
316 [ "$rootfs_length" ] && rootfs_type="$(identify_tar "$tar_file" "$board_dir/root" "$gz")"
317
318 local ubi_kernel_length
319 if [ "$kernel_length" ]; then
320 if [ "$kernel_mtd" ]; then
321 # On some devices, the raw kernel and ubi partitions overlap.
322 # These devices brick if the kernel partition is erased.
323 # Hence only invalidate kernel for now.
324 dd if=/dev/zero bs=4096 count=1 2> /dev/null | \
325 mtd write - "$CI_KERNPART"
326 else
327 ubi_kernel_length="$kernel_length"
328 fi
329 fi
330 local has_env=0
331 nand_upgrade_prepare_ubi "$rootfs_length" "$rootfs_type" "$ubi_kernel_length" "$has_env" || return 1
332
333 if [ "$rootfs_length" ]; then
334 local ubidev="$( nand_find_ubi "${CI_ROOT_UBIPART:-$CI_UBIPART}" )"
335 local root_ubivol="$( nand_find_volume $ubidev "$CI_ROOTPART" )"
336 tar xO${gz}f "$tar_file" "$board_dir/root" | \
337 ubiupdatevol /dev/$root_ubivol -s "$rootfs_length" -
338 fi
339 if [ "$kernel_length" ]; then
340 if [ "$kernel_mtd" ]; then
341 tar xO${gz}f "$tar_file" "$board_dir/kernel" | \
342 mtd write - "$CI_KERNPART"
343 else
344 local ubidev="$( nand_find_ubi "${CI_KERN_UBIPART:-$CI_UBIPART}" )"
345 local kern_ubivol="$( nand_find_volume $ubidev "$CI_KERNPART" )"
346 tar xO${gz}f "$tar_file" "$board_dir/kernel" | \
347 ubiupdatevol /dev/$kern_ubivol -s "$kernel_length" -
348 fi
349 fi
350
351 return 0
352 }
353
354 nand_verify_if_gzip_file() {
355 local file="$1"
356 local gz="$2"
357
358 if [ "$gz" = z ]; then
359 echo "verifying compressed sysupgrade file integrity"
360 if ! gzip -t "$file"; then
361 echo "corrupted compressed sysupgrade file"
362 return 1
363 fi
364 fi
365 }
366
367 nand_verify_tar_file() {
368 local file="$1"
369 local gz="$2"
370
371 echo "verifying sysupgrade tar file integrity"
372 if ! tar xO${gz}f "$file" > /dev/null; then
373 echo "corrupted sysupgrade tar file"
374 return 1
375 fi
376 }
377
378 nand_do_flash_file() {
379 local file="$1"
380
381 local gz="$(identify_if_gzip "$file")"
382 local file_type="$(identify "$file" "" "$gz")"
383
384 [ ! "$(find_mtd_index "$CI_UBIPART")" ] && CI_UBIPART=rootfs
385
386 case "$file_type" in
387 "fit")
388 nand_verify_if_gzip_file "$file" "$gz" || return 1
389 nand_upgrade_fit "$file" "$gz"
390 ;;
391 "ubi")
392 nand_verify_if_gzip_file "$file" "$gz" || return 1
393 nand_upgrade_ubinized "$file" "$gz"
394 ;;
395 "ubifs")
396 nand_verify_if_gzip_file "$file" "$gz" || return 1
397 nand_upgrade_ubifs "$file" "$gz"
398 ;;
399 *)
400 nand_verify_tar_file "$file" "$gz" || return 1
401 nand_upgrade_tar "$file" "$gz"
402 ;;
403 esac
404 }
405
406 nand_do_restore_config() {
407 local conf_tar="/tmp/sysupgrade.tgz"
408 [ ! -f "$conf_tar" ] || nand_restore_config "$conf_tar"
409 }
410
411 # Recognize type of passed file and start the upgrade process
412 nand_do_upgrade() {
413 local file="$1"
414
415 sync
416 nand_do_flash_file "$file" && nand_do_upgrade_success
417 nand_do_upgrade_failed
418 }
419
420 nand_do_upgrade_success() {
421 if nand_do_restore_config && sync; then
422 echo "sysupgrade successful"
423 umount -a
424 reboot -f
425 fi
426 nand_do_upgrade_failed
427 }
428
429 nand_do_upgrade_failed() {
430 sync
431 echo "sysupgrade failed"
432 # Should we reboot or bring up some failsafe mode instead?
433 umount -a
434 reboot -f
435 }
436
437 # Check if passed file is a valid one for NAND sysupgrade.
438 # Currently it accepts 4 types of files:
439 # 1) UBI: a ubinized image containing required UBI volumes.
440 # 2) UBIFS: a UBIFS rootfs volume image.
441 # 3) FIT: a FIT image containing kernel and rootfs.
442 # 4) TAR: an archive that includes directory "sysupgrade-${BOARD_NAME}" containing
443 # a non-empty "CONTROL" file and required partition and/or volume images.
444 #
445 # You usually want to call this function in platform_check_image.
446 #
447 # $(1): board name, used in case of passing TAR file
448 # $(2): file to be checked
449 nand_do_platform_check() {
450 local board_name="$1"
451 local file="$2"
452
453 local gz="$(identify_if_gzip "$file")"
454 local file_type="$(identify "$file" "" "$gz")"
455 local control_length=$( (tar xO${gz}f "$file" "sysupgrade-${board_name//,/_}/CONTROL" | wc -c) 2> /dev/null)
456
457 if [ "$control_length" = 0 ]; then
458 control_length=$( (tar xO${gz}f "$file" "sysupgrade-${board_name//_/,}/CONTROL" | wc -c) 2> /dev/null)
459 fi
460
461 if [ "$control_length" != 0 ]; then
462 nand_verify_tar_file "$file" "$gz" || return 1
463 else
464 nand_verify_if_gzip_file "$file" "$gz" || return 1
465 if [ "$file_type" != "fit" -a "$file_type" != "ubi" -a "$file_type" != "ubifs" ]; then
466 echo "invalid sysupgrade file"
467 return 1
468 fi
469 fi
470
471 return 0
472 }